diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/qos-txop.cc ns-3.35/src/wifi/model/qos-txop.cc
--- ns-3.34/src/wifi/model/qos-txop.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/qos-txop.cc	2021-10-01 13:26:48.000000000 -0700
@@ -32,7 +32,6 @@
 #include "wifi-mac-trailer.h"
 #include "wifi-mac-queue.h"
 #include "qos-blocked-destinations.h"
-#include "wifi-remote-station-manager.h"
 #include "msdu-aggregator.h"
 #include "mpdu-aggregator.h"
 #include "ctrl-headers.h"
@@ -42,7 +41,7 @@
 #include "wifi-tx-parameters.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT if (m_stationManager != 0 && m_stationManager->GetMac () != 0) { std::clog << "[mac=" << m_stationManager->GetMac ()->GetAddress () << "] "; }
+#define NS_LOG_APPEND_CONTEXT if (m_mac != 0) { std::clog << "[mac=" << m_mac->GetAddress () << "] "; }
 
 namespace ns3 {
 
@@ -91,9 +90,16 @@
   return tid;
 }
 
-QosTxop::QosTxop ()
-  : m_startTxop (Seconds (0)),
-    m_txopDuration (Seconds (0))
+QosTxop::QosTxop (AcIndex ac)
+  : Txop (CreateObject<WifiMacQueue> (ac)),
+    m_ac (ac),
+    m_startTxop (Seconds (0)),
+    m_txopDuration (Seconds (0)),
+    m_muCwMin (0),
+    m_muCwMax (0),
+    m_muAifsn (0),
+    m_muEdcaTimer (Seconds (0)),
+    m_muEdcaTimerStartTime (Seconds (0))
 {
   NS_LOG_FUNCTION (this);
   m_qosBlockedDestinations = Create<QosBlockedDestinations> ();
@@ -101,6 +107,7 @@
   m_baManager->SetQueue (m_queue);
   m_baManager->SetBlockDestinationCallback (MakeCallback (&QosBlockedDestinations::Block, m_qosBlockedDestinations));
   m_baManager->SetUnblockDestinationCallback (MakeCallback (&QosBlockedDestinations::Unblock, m_qosBlockedDestinations));
+  m_queue->TraceConnectWithoutContext ("Expired", MakeCallback (&BlockAckManager::NotifyDiscardedMpdu, m_baManager));
 }
 
 QosTxop::~QosTxop ()
@@ -112,26 +119,24 @@
 QosTxop::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
+  if (m_baManager != 0)
+    {
+      m_baManager->Dispose ();
+    }
   m_baManager = 0;
   m_qosBlockedDestinations = 0;
   m_qosFem = 0;
   Txop::DoDispose ();
 }
 
-void
-QosTxop::SetQosQueueSize (Ptr<WifiMacQueueItem> mpdu)
+uint8_t
+QosTxop::GetQosQueueSize (uint8_t tid, Mac48Address receiver) const
 {
-  NS_LOG_FUNCTION (this << *mpdu);
-
-  WifiMacHeader& hdr = mpdu->GetHeader ();
-  NS_ASSERT (hdr.IsQosData ());
-
-  uint32_t bufferSize = m_queue->GetNBytes (hdr.GetQosTid (), hdr.GetAddr1 ())
-                        + m_baManager->GetRetransmitQueue ()->GetNBytes (hdr.GetQosTid (), hdr.GetAddr1 ());
+  uint32_t bufferSize = m_queue->GetNBytes (tid, receiver);
   // A queue size value of 254 is used for all sizes greater than 64 768 octets.
   uint8_t queueSize = static_cast<uint8_t> (std::ceil (std::min (bufferSize, 64769u) / 256.0));
   NS_LOG_DEBUG ("Buffer size=" << bufferSize << " Queue Size=" << +queueSize);
-  hdr.SetQosQueueSize (queueSize);
+  return queueSize;
 }
 
 void
@@ -146,9 +151,92 @@
 {
   NS_LOG_FUNCTION (this << &callback);
   Txop::SetDroppedMpduCallback (callback);
-  m_baManager->GetRetransmitQueue ()->TraceConnectWithoutContext ("Expired",
-                                                                  m_droppedMpduCallback
-                                                                  .Bind (WIFI_MAC_DROP_EXPIRED_LIFETIME));
+  m_baManager->SetDroppedOldMpduCallback (callback.Bind (WIFI_MAC_DROP_QOS_OLD_PACKET));
+}
+
+void
+QosTxop::SetMuCwMin (uint16_t cwMin)
+{
+  NS_LOG_FUNCTION (this << cwMin);
+  m_muCwMin = cwMin;
+}
+
+void
+QosTxop::SetMuCwMax (uint16_t cwMax)
+{
+  NS_LOG_FUNCTION (this << cwMax);
+  m_muCwMax = cwMax;
+}
+
+void
+QosTxop::SetMuAifsn (uint8_t aifsn)
+{
+  NS_LOG_FUNCTION (this << +aifsn);
+  m_muAifsn = aifsn;
+}
+
+void
+QosTxop::SetMuEdcaTimer (Time timer)
+{
+  NS_LOG_FUNCTION (this << timer);
+  m_muEdcaTimer = timer;
+}
+
+void
+QosTxop::StartMuEdcaTimerNow (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_muEdcaTimerStartTime = Simulator::Now ();
+  if (EdcaDisabled ())
+    {
+      NS_LOG_DEBUG ("Disable EDCA for " << m_muEdcaTimer.As (Time::MS));
+      m_channelAccessManager->DisableEdcaFor (this, m_muEdcaTimer);
+    }
+}
+
+bool
+QosTxop::MuEdcaTimerRunning (void) const
+{
+  return (m_muEdcaTimerStartTime.IsStrictlyPositive () && m_muEdcaTimer.IsStrictlyPositive ()
+          && m_muEdcaTimerStartTime + m_muEdcaTimer > Simulator::Now ());
+}
+
+bool
+QosTxop::EdcaDisabled (void) const
+{
+  return (MuEdcaTimerRunning () && m_muAifsn == 0);
+}
+
+uint32_t
+QosTxop::GetMinCw (void) const
+{
+  if (!MuEdcaTimerRunning ())
+    {
+      return m_cwMin;
+    }
+  NS_ASSERT (!EdcaDisabled ());
+  return m_muCwMin;
+}
+
+uint32_t
+QosTxop::GetMaxCw (void) const
+{
+  if (!MuEdcaTimerRunning ())
+    {
+      return m_cwMax;
+    }
+  NS_ASSERT (!EdcaDisabled ());
+  return m_muCwMax;
+}
+
+uint8_t
+QosTxop::GetAifsn (void) const
+{
+  if (!MuEdcaTimerRunning ())
+    {
+      return m_aifsn;
+    }
+  return m_muAifsn;
 }
 
 Ptr<BlockAckManager>
@@ -188,7 +276,7 @@
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_CTL_BACKREQ);
   hdr.SetAddr1 (recipient);
-  hdr.SetAddr2 (m_stationManager->GetMac ()->GetAddress ());
+  hdr.SetAddr2 (m_mac->GetAddress ());
   hdr.SetDsNotTo ();
   hdr.SetDsNotFrom ();
   hdr.SetNoRetry ();
@@ -203,14 +291,6 @@
   m_baManager->ScheduleBar (bar, skipIfNoDataQueued);
 }
 
-void
-QosTxop::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager)
-{
-  Txop::SetWifiRemoteStationManager (remoteManager);
-  NS_LOG_FUNCTION (this << remoteManager);
-  m_baManager->SetWifiRemoteStationManager (m_stationManager);
-}
-
 bool
 QosTxop::UseExplicitBarAfterMissedBlockAck (void) const
 {
@@ -220,10 +300,10 @@
 bool
 QosTxop::HasFramesToTransmit (void)
 {
-  // check if the BA manager retransmit queue is empty, so that expired
+  // check if the BA manager has anything to send, so that expired
   // frames (if any) are removed and a BlockAckRequest is scheduled to advance
   // the starting sequence number of the transmit (and receiver) window
-  bool baManagerHasPackets = m_baManager->HasPackets ();
+  bool baManagerHasPackets = (m_baManager->GetBar (false) != 0);
   // remove MSDUs with expired lifetime starting from the head of the queue
   // TODO Add a WifiMacQueue method that serves this purpose; IsEmpty () can
   // then reuse such method.
@@ -276,11 +356,11 @@
 Ptr<const WifiMacQueueItem>
 QosTxop::PeekNextMpdu (uint8_t tid, Mac48Address recipient)
 {
-  return PeekNextMpdu ({nullptr, WifiMacQueue::EMPTY}, tid, recipient);
+  return PeekNextMpdu (WifiMacQueue::EMPTY, tid, recipient);
 }
 
 Ptr<const WifiMacQueueItem>
-QosTxop::PeekNextMpdu (WifiMacQueueItem::QueueIteratorPair queueIt, uint8_t tid, Mac48Address recipient)
+QosTxop::PeekNextMpdu (WifiMacQueueItem::ConstIterator queueIt, uint8_t tid, Mac48Address recipient)
 {
   NS_LOG_FUNCTION (this << +tid << recipient);
 
@@ -289,50 +369,55 @@
     {
       if (tid == 8 && recipient.IsBroadcast ())  // undefined TID and recipient
         {
-          return queueIt.queue->PeekFirstAvailable (m_qosBlockedDestinations, queueIt.it);
+          return m_queue->PeekFirstAvailable (m_qosBlockedDestinations, queueIt);
         }
       if (m_qosBlockedDestinations->IsBlocked (recipient, tid))
         {
-          return queueIt.queue->end ();
+          return m_queue->end ();
         }
-      return queueIt.queue->PeekByTidAndAddress (tid, recipient, queueIt.it);
+      return m_queue->PeekByTidAndAddress (tid, recipient, queueIt);
     };
 
-  if (queueIt.queue == nullptr && queueIt.it == WifiMacQueue::EMPTY)
-    {
-      // check if there is a packet in the BlockAckManager retransmit queue
-      queueIt.queue = PeekPointer (m_baManager->GetRetransmitQueue ());
-    }
-
-  if (queueIt.queue == PeekPointer (m_baManager->GetRetransmitQueue ()))
+  queueIt = peek ();
+  // remove old packets (must be retransmissions or in flight, otherwise they did
+  // not get a sequence number assigned)
+  while (queueIt != m_queue->end () && !(*queueIt)->IsFragment ())
     {
-      queueIt.it = peek ();
-      // remove old packets
-      while (queueIt.it != m_baManager->GetRetransmitQueue ()->end () && IsQosOldPacket (*queueIt.it))
+      if (((*queueIt)->GetHeader ().IsRetry () || (*queueIt)->IsInFlight ())
+          && IsQosOldPacket (*queueIt))
         {
-          NS_LOG_DEBUG ("Removing an old packet from BlockAckManager retransmit queue: " << **queueIt.it);
-          queueIt.it = m_baManager->GetRetransmitQueue ()->Remove (queueIt.it);
-          queueIt.it = peek ();
+          NS_LOG_DEBUG ("Removing an old packet from EDCA queue: " << **queueIt);
+          if (!m_droppedMpduCallback.IsNull ())
+            {
+              m_droppedMpduCallback (WIFI_MAC_DROP_QOS_OLD_PACKET, *queueIt);
+            }
+          queueIt = m_queue->Remove (queueIt);
+          queueIt = peek ();
         }
-      if (queueIt.it != m_baManager->GetRetransmitQueue ()->end ())
+      else if ((*queueIt)->IsInFlight ())
+        {
+          NS_LOG_DEBUG ("Skipping in flight MPDU: " << **queueIt);
+          ++queueIt;
+          queueIt = peek ();
+        }
+      else
         {
-          NS_LOG_DEBUG ("Packet peeked from BlockAckManager retransmit queue: " << **queueIt.it);
-          return *queueIt.it;
+          break;
         }
-      // otherwise, check if there is a packet in the EDCA queue
-      queueIt = {PeekPointer (m_queue), WifiMacQueue::EMPTY};
     }
-
-  queueIt.it = peek ();
-  if (queueIt.it != m_queue->end ())
+  if (queueIt != m_queue->end ())
     {
+      NS_ASSERT (!(*queueIt)->IsInFlight ());
+      WifiMacHeader& hdr = (*queueIt)->GetHeader ();
+
       // peek the next sequence number and check if it is within the transmit window
       // in case of QoS data frame
-      uint16_t sequence = m_txMiddle->PeekNextSequenceNumberFor (&(*queueIt.it)->GetHeader ());
-      if ((*queueIt.it)->GetHeader ().IsQosData ())
+      uint16_t sequence = (hdr.IsRetry () ? hdr.GetSequenceNumber ()
+                                          : m_txMiddle->PeekNextSequenceNumberFor (&hdr));
+      if (hdr.IsQosData ())
         {
-          Mac48Address recipient = (*queueIt.it)->GetHeader ().GetAddr1 ();
-          uint8_t tid = (*queueIt.it)->GetHeader ().GetQosTid ();
+          Mac48Address recipient = hdr.GetAddr1 ();
+          uint8_t tid = hdr.GetQosTid ();
 
           if (GetBaAgreementEstablished (recipient, tid)
               && !IsInWindow (sequence, GetBaStartingSequence (recipient, tid), GetBaBufferSize (recipient, tid)))
@@ -342,14 +427,13 @@
             }
         }
 
-      WifiMacHeader& hdr = (*queueIt.it)->GetHeader ();
       // Assign a sequence number if this is not a fragment nor a retransmission
-      if (!(*queueIt.it)->IsFragment () && !hdr.IsRetry ())
+      if (!(*queueIt)->IsFragment () && !hdr.IsRetry ())
         {
           hdr.SetSequenceNumber (sequence);
         }
-      NS_LOG_DEBUG ("Packet peeked from EDCA queue: " << **queueIt.it);
-      return *queueIt.it;
+      NS_LOG_DEBUG ("Packet peeked from EDCA queue: " << **queueIt);
+      return *queueIt;
     }
 
   return 0;
@@ -357,7 +441,7 @@
 
 Ptr<WifiMacQueueItem>
 QosTxop::GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                      Time availableTime, bool initialFrame, WifiMacQueueItem::QueueIteratorPair& queueIt)
+                      Time availableTime, bool initialFrame, WifiMacQueueItem::ConstIterator& queueIt)
 {
   NS_ASSERT (peekedItem != 0);
   NS_ASSERT (m_qosFem != 0);
@@ -377,40 +461,9 @@
     }
 
   NS_ASSERT (peekedItem->IsQueued ());
-  NS_ASSERT_MSG (peekedItem->GetQueueIteratorPairs ().size () == 1,
-                 "An item in the MAC queue cannot contain an A-MSDU");
-  WifiMacQueueItem::QueueIteratorPair peekedIt = peekedItem->GetQueueIteratorPairs ().front ();
-  NS_ASSERT ((*peekedIt.it)->GetPacket () == peekedItem->GetPacket ());
-
-  if (peekedIt.queue == PeekPointer (m_baManager->GetRetransmitQueue ()))
-    {
-      // the packet can only have been peeked from the block ack manager retransmit
-      // queue if:
-      // - the peeked packet is a QoS Data frame AND
-      // - the peeked packet is not a broadcast frame AND
-      // - an agreement has been established
-      NS_ASSERT (peekedItem->GetHeader ().IsQosData () && !recipient.IsBroadcast ());
-      uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
-      NS_ASSERT (GetBaAgreementEstablished (recipient, tid));
-      // we should not be asked to dequeue an old packet
-      NS_ASSERT (!QosUtilsIsOldPacket (GetBaStartingSequence (recipient, tid),
-                                       peekedItem->GetHeader ().GetSequenceNumber ()));
-      // we should not be asked to dequeue an MPDU that is beyond the transmit window
-      NS_ASSERT (IsInWindow (peekedItem->GetHeader ().GetSequenceNumber (),
-                             GetBaStartingSequence (recipient, tid),
-                             GetBaBufferSize (recipient, tid)));
-      // A-MSDU aggregation cannot be done on a retransmitted MPDU, hence return
-      // the peeked MPDU
-      NS_LOG_DEBUG ("Got MPDU from BA manager queue: " << *peekedItem);
-
-      queueIt = peekedIt;
-      queueIt.it++;
-
-      return *peekedIt.it;
-    }
-
-  // The MPDU has been peeked from the EDCA queue.
-  NS_ASSERT (peekedIt.queue == PeekPointer (m_queue));
+  WifiMacQueueItem::ConstIterator peekedIt = peekedItem->GetQueueIterator ();
+  NS_ASSERT ((*peekedIt)->GetPacket () == peekedItem->GetPacket ());
+  NS_ASSERT ((*peekedIt)->GetQueueAc () == m_ac);
   Ptr<WifiMacQueueItem> mpdu;
 
   // If it is a non-broadcast QoS Data frame and it is not a retransmission nor a fragment,
@@ -428,8 +481,9 @@
                                 GetBaBufferSize (recipient, tid)));
 
       // try A-MSDU aggregation
-      if (m_stationManager->GetHtSupported () && !recipient.IsBroadcast ()
-          && !peekedItem->GetHeader ().IsRetry () && !peekedItem->IsFragment ())
+      if (m_mac->GetHtSupported () && !recipient.IsBroadcast ()
+          && !peekedItem->GetHeader ().IsRetry () && !peekedItem->IsFragment ()
+          && !peekedItem->IsInFlight ())
         {
           Ptr<HtFrameExchangeManager> htFem = StaticCast<HtFrameExchangeManager> (m_qosFem);
           mpdu = htFem->GetMsduAggregator ()->GetNextAmsdu (peekedItem, txParams, availableTime, peekedIt);
@@ -444,8 +498,8 @@
 
   if (mpdu == 0)
     {
-      mpdu = *peekedIt.it;
-      peekedIt.it++;
+      mpdu = *peekedIt;
+      peekedIt++;
     }
 
   // Assign a sequence number if this is not a fragment nor a retransmission
@@ -461,7 +515,7 @@
 {
   NS_LOG_FUNCTION (this << *mpdu);
 
-  if (!mpdu->IsFragment () && !mpdu->GetHeader ().IsRetry ())
+  if (!mpdu->IsFragment () && !mpdu->GetHeader ().IsRetry () && !mpdu->IsInFlight ())
     {
       uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&mpdu->GetHeader ());
       mpdu->GetHeader ().SetSequenceNumber (sequence);
@@ -481,88 +535,6 @@
 }
 
 void
-QosTxop::NotifyInternalCollision (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  // For internal collisions occurring with the EDCA access method, the appropriate
-  // retry counters (short retry counter for MSDU, A-MSDU, or MMPDU and QSRC[AC] or
-  // long retry counter for MSDU, A-MSDU, or MMPDU and QLRC[AC]) are incremented
-  // (Sec. 10.22.2.11.1 of 802.11-2016).
-  // We do not prepare the PSDU that the AC losing the internal collision would have
-  // sent. As an approximation, we consider the frame peeked from the queues of the AC.
-  Ptr<const WifiMacQueueItem> mpdu = PeekNextMpdu ();
-
-  if (mpdu != nullptr)
-    {
-      m_stationManager->ReportDataFailed (mpdu);
-
-      if (!mpdu->GetHeader ().GetAddr1 ().IsGroup () && !m_stationManager->NeedRetransmission (mpdu))
-        {
-          NS_LOG_DEBUG ("reset DCF");
-          m_stationManager->ReportFinalDataFailed (mpdu);
-          if (!m_droppedMpduCallback.IsNull ())
-            {
-              m_droppedMpduCallback (WIFI_MAC_DROP_REACHED_RETRY_LIMIT, mpdu);
-            }
-          ResetCw ();
-          // We have to discard mpdu, but first we have to determine whether mpdu
-          // is stored in the Block Ack Manager retransmit queue or in the AC queue
-          Mac48Address receiver = mpdu->GetHeader ().GetAddr1 ();
-          WifiMacQueue::ConstIterator testIt;
-          bool found = false;
-
-          if (mpdu->GetHeader ().IsQosData ()
-              && GetBaAgreementEstablished (receiver, mpdu->GetHeader ().GetQosTid ()))
-            {
-              uint8_t tid = mpdu->GetHeader ().GetQosTid ();
-              testIt = m_baManager->GetRetransmitQueue ()->PeekByTidAndAddress (tid, receiver);
-
-              if (testIt != m_baManager->GetRetransmitQueue ()->end ())
-                {
-                  found = true;
-                  // if not null, the test packet must equal the peeked packet
-                  NS_ASSERT ((*testIt)->GetPacket () == mpdu->GetPacket ());
-                  m_baManager->GetRetransmitQueue ()->Remove (testIt);
-                  m_baManager->NotifyDiscardedMpdu (mpdu);
-                }
-            }
-
-          if (!found)
-            {
-              if (mpdu->GetHeader ().IsQosData ())
-                {
-                  uint8_t tid = mpdu->GetHeader ().GetQosTid ();
-                  testIt = m_queue->PeekByTidAndAddress (tid, receiver);
-                  NS_ASSERT (testIt != m_queue->end () && (*testIt)->GetPacket () == mpdu->GetPacket ());
-                  m_queue->Remove (testIt);
-                }
-              else
-                {
-                  // the peeked packet is a non-QoS Data frame (e.g., a DELBA Request), hence
-                  // it was not peeked by TID, hence it must be the head of the queue
-                  Ptr<WifiMacQueueItem> item;
-                  item = m_queue->DequeueFirstAvailable (m_qosBlockedDestinations);
-                  NS_ASSERT (item != 0 && item->GetPacket () == mpdu->GetPacket ());
-                }
-            }
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Update CW");
-          UpdateFailedCw ();
-        }
-    }
-
-  GenerateBackoff ();
-  m_access = NOT_REQUESTED;
-  if (HasFramesToTransmit ())
-    {
-      m_channelAccessManager->RequestAccess (this);
-    }
-}
-
-void
 QosTxop::NotifyChannelAccessed (Time txopDuration)
 {
   NS_LOG_FUNCTION (this << txopDuration);
@@ -609,13 +581,6 @@
 }
 
 void
-QosTxop::SetAccessCategory (AcIndex ac)
-{
-  NS_LOG_FUNCTION (this << +ac);
-  m_ac = ac;
-}
-
-void
 QosTxop::PushFront (Ptr<const Packet> packet, const WifiMacHeader &hdr)
 {
   NS_LOG_FUNCTION (this << packet << &hdr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/qos-txop.h ns-3.35/src/wifi/model/qos-txop.h
--- ns-3.34/src/wifi/model/qos-txop.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/qos-txop.h	2021-10-01 13:26:48.000000000 -0700
@@ -44,9 +44,8 @@
  * \ingroup wifi
  *
  * This class implements the packet fragmentation and retransmission policy for
- * QoS data frames. It uses the ns3::MacLow and ns3::ChannelAccessManager helper classes
- * to respectively send packets and decide when to send them. Packets are stored
- * in a ns3::WifiMacQueue until they can be sent.
+ * QoS data frames. It uses the ns3::ChannelAccessManager helper class to decide
+ * when to send a packet. Packets are stored in a ns3::WifiMacQueue until they can be sent.
  *
  * This queue contains packets for a particular access class.
  * Possibles access classes are:
@@ -56,8 +55,6 @@
  *   - AC_BK : background, TID = 1,2
  *
  * This class also implements block ack sessions and MSDU aggregation (A-MSDU).
- * If A-MSDU is enabled for that access class, it picks several packets from the
- * queue instead of a single one and sends the aggregated packet to ns3::MacLow.
  *
  * The fragmentation policy currently implemented uses a simple
  * threshold: any packet bigger than this threshold is fragmented
@@ -80,14 +77,17 @@
    */
   static TypeId GetTypeId (void);
 
-  QosTxop ();
+  /**
+   * Constructor
+   *
+   * \param ac the Access Category
+   */
+  QosTxop (AcIndex ac = AC_UNDEF);
+
   virtual ~QosTxop ();
 
   bool IsQosTxop (void) const override;
-  AcIndex GetAccessCategory (void) const override;
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager) override;
   bool HasFramesToTransmit (void) override;
-  void NotifyInternalCollision (void) override;
   void NotifyChannelAccessed (Time txopDuration) override;
   void NotifyChannelReleased (void) override;
   void SetDroppedMpduCallback (DroppedMpdu callback) override;
@@ -100,6 +100,13 @@
   void SetQosFrameExchangeManager (const Ptr<QosFrameExchangeManager> qosFem);
 
   /**
+   * Get the access category of this object.
+   *
+   * \return the access category.
+   */
+  AcIndex GetAccessCategory (void) const;
+
+  /**
    * Return true if an explicit BlockAckRequest is sent after a missed BlockAck
    *
    * \return true if an explicit BlockAckRequest is sent after a missed BlockAck
@@ -212,13 +219,6 @@
   void ResetBa (Mac48Address recipient, uint8_t tid);
 
   /**
-   * Set the access category of this EDCAF.
-   *
-   * \param ac access category.
-   */
-  void SetAccessCategory (AcIndex ac);
-
-  /**
    * \param packet packet to send.
    * \param hdr header of packet to send.
    *
@@ -332,7 +332,7 @@
    * \param recipient the receiver station address.
    * \returns the peeked frame.
    */
-  Ptr<const WifiMacQueueItem> PeekNextMpdu (WifiMacQueueItem::QueueIteratorPair queueIt,
+  Ptr<const WifiMacQueueItem> PeekNextMpdu (WifiMacQueueItem::ConstIterator queueIt,
                                             uint8_t tid = 8,
                                             Mac48Address recipient = Mac48Address::GetBroadcast ());
   /**
@@ -351,14 +351,14 @@
                           (including protection and acknowledgment); a value of
    *                      Time::Min() indicates no time constraint
    * \param initialFrame true if the frame is the initial PPDU of a TXOP
-   * \param[out] queueIt a QueueIteratorPair pointing to the queue item following the
+   * \param[out] queueIt a queue iterator pointing to the queue item following the
    *                     last item used to prepare the returned MPDU, if any; if no MPDU
    *                     is returned, its value is unchanged
    * \return the frame to transmit or a null pointer if no frame meets the time constraints
    */
   Ptr<WifiMacQueueItem> GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
                                      Time availableTime, bool initialFrame,
-                                     WifiMacQueueItem::QueueIteratorPair& queueIt);
+                                     WifiMacQueueItem::ConstIterator& queueIt);
 
   /**
    * Assign a sequence number to the given MPDU, if it is not a fragment
@@ -369,11 +369,14 @@
   void AssignSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const;
 
   /**
-   * Set the Queue Size subfield of the QoS Control field of the given QoS data frame.
+   * Get the value for the Queue Size subfield of the QoS Control field of a
+   * QoS data frame of the given TID and addressed to the given receiver.
    *
-   * \param mpdu the given QoS data frame
+   * \param tid the Traffic ID
+   * \param receiver the address of the given receiver
+   * \return the value for the Queue Size subfield
    */
-  void SetQosQueueSize (Ptr<WifiMacQueueItem> mpdu);
+  uint8_t GetQosQueueSize (uint8_t tid, Mac48Address receiver) const;
 
   /**
    * Return true if a TXOP has started.
@@ -388,6 +391,75 @@
    */
   virtual Time GetRemainingTxop (void) const;
 
+  /**
+   * Set the minimum contention window size to use while the MU EDCA Timer
+   * is running.
+   *
+   * \param cwMin the minimum contention window size.
+   */
+  void SetMuCwMin (uint16_t cwMin);
+  /**
+   * Set the maximum contention window size to use while the MU EDCA Timer
+   * is running.
+   *
+   * \param cwMax the maximum contention window size.
+   */
+  void SetMuCwMax (uint16_t cwMax);
+  /**
+   * Set the number of slots that make up an AIFS while the MU EDCA Timer
+   * is running.
+   *
+   * \param aifsn the number of slots that make up an AIFS.
+   */
+  void SetMuAifsn (uint8_t aifsn);
+  /**
+   * Set the MU EDCA Timer.
+   *
+   * \param timer the timer duration.
+   */
+  void SetMuEdcaTimer (Time timer);
+  /**
+   * Start the MU EDCA Timer.
+   */
+  void StartMuEdcaTimerNow (void);
+  /**
+   * Return true if the MU EDCA Timer is running, false otherwise.
+   *
+   * \return whether the MU EDCA Timer is running
+   */
+  bool MuEdcaTimerRunning (void) const;
+  /**
+   * Return true if the EDCA is disabled (the MU EDCA Timer is running and the
+   * MU AIFSN is zero), false otherwise.
+   *
+   * \return whether the EDCA is disabled
+   */
+  bool EdcaDisabled (void) const;
+  /**
+   * Return the minimum contention window size from the EDCA Parameter Set
+   * or the MU EDCA Parameter Set, depending on whether the MU EDCA Timer is
+   * running or not.
+   *
+   * \return the currently used minimum contention window size.
+   */
+  uint32_t GetMinCw (void) const override;
+  /**
+   * Return the maximum contention window size from the EDCA Parameter Set
+   * or the MU EDCA Parameter Set, depending on whether the MU EDCA Timer is
+   * running or not.
+   *
+   * \return the currently used maximum contention window size.
+   */
+  uint32_t GetMaxCw (void) const override;
+  /**
+   * Return the number of slots that make up an AIFS according to the
+   * EDCA Parameter Set or the MU EDCA Parameter Set, depending on whether the
+   * MU EDCA Timer is running or not.
+   *
+   * \return the number of slots that currently make up an AIFS.
+   */
+  uint8_t GetAifsn (void) const override;
+
 protected:
   void DoDispose (void) override;
 
@@ -422,6 +494,12 @@
   Time m_failedAddBaTimeout;                            //!< timeout after failed BA agreement
   bool m_useExplicitBarAfterMissedBlockAck;             //!< flag whether explicit BlockAckRequest should be sent upon missed BlockAck Response
 
+  uint32_t m_muCwMin;          //!< the MU CW minimum
+  uint32_t m_muCwMax;          //!< the MU CW maximum
+  uint8_t m_muAifsn;           //!< the MU AIFSN
+  Time m_muEdcaTimer;          //!< the MU EDCA Timer
+  Time m_muEdcaTimerStartTime; //!< last start time of the MU EDCA Timer
+
   TracedCallback<Time, Time> m_txopTrace; //!< TXOP trace callback
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/qos-utils.h ns-3.35/src/wifi/model/qos-utils.h
--- ns-3.34/src/wifi/model/qos-utils.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/qos-utils.h	2021-10-01 13:26:48.000000000 -0700
@@ -77,8 +77,11 @@
   AC_VI = 2,
   /** Voice */
   AC_VO = 3,
-  /** Total number of ACs */
+  /** Non-QoS */
   AC_BE_NQOS = 4,
+  /** Beacon queue */
+  AC_BEACON = 5,
+  /** Total number of ACs */
   AC_UNDEF
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/regular-wifi-mac.cc ns-3.35/src/wifi/model/regular-wifi-mac.cc
--- ns-3.34/src/wifi/model/regular-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/regular-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
@@ -37,6 +37,7 @@
 #include <cmath>
 #include "ns3/he-frame-exchange-manager.h"
 #include "channel-access-manager.h"
+#include "wifi-mac-queue.h"
 
 namespace ns3 {
 
@@ -59,6 +60,7 @@
 
   m_txop = CreateObject<Txop> ();
   m_txop->SetChannelAccessManager (m_channelAccessManager);
+  m_txop->SetWifiMac (this);
   m_txop->SetTxMiddle (m_txMiddle);
   m_txop->SetDroppedMpduCallback (MakeCallback (&DroppedMpduTracedCallback::operator(),
                                                 &m_droppedMpduCallback));
@@ -182,11 +184,6 @@
 {
   NS_LOG_FUNCTION (this << stationManager);
   m_stationManager = stationManager;
-  m_txop->SetWifiRemoteStationManager (stationManager);
-  for (EdcaQueues::const_iterator i = m_edca.begin (); i != m_edca.end (); ++i)
-    {
-      i->second->SetWifiRemoteStationManager (stationManager);
-    }
 }
 
 Ptr<WifiRemoteStationManager>
@@ -467,8 +464,9 @@
   //already configured.
   NS_ASSERT (m_edca.find (ac) == m_edca.end ());
 
-  Ptr<QosTxop> edca = CreateObject<QosTxop> ();
+  Ptr<QosTxop> edca = CreateObject<QosTxop> (ac);
   edca->SetChannelAccessManager (m_channelAccessManager);
+  edca->SetWifiMac (this);
   edca->SetTxMiddle (m_txMiddle);
   edca->GetBaManager ()->SetTxOkCallback (MakeCallback (&MpduTracedCallback::operator(),
                                                         &m_ackedMpduCallback));
@@ -476,7 +474,6 @@
                                                             &m_nackedMpduCallback));
   edca->SetDroppedMpduCallback (MakeCallback (&DroppedMpduTracedCallback::operator(),
                                               &m_droppedMpduCallback));
-  edca->SetAccessCategory (ac);
 
   m_edca.insert (std::make_pair (ac, edca));
 }
@@ -536,6 +533,17 @@
   return m_edca.find (AC_BK)->second;
 }
 
+Ptr<WifiMacQueue>
+RegularWifiMac::GetTxopQueue (AcIndex ac) const
+{
+  if (ac == AC_BE_NQOS)
+    {
+      return m_txop->GetWifiMacQueue ();
+    }
+  NS_ASSERT (ac == AC_BE || ac == AC_BK || ac == AC_VI || ac == AC_VO);
+  return m_edca.find (ac)->second->GetWifiMacQueue ();
+}
+
 void
 RegularWifiMac::SetWifiPhy (const Ptr<WifiPhy> phy)
 {
@@ -1152,4 +1160,54 @@
     }
 }
 
+uint32_t
+RegularWifiMac::GetMaxAmpduSize (AcIndex ac) const
+{
+  uint32_t maxSize = 0;
+  switch (ac)
+    {
+      case AC_BE:
+        maxSize = m_beMaxAmpduSize;
+        break;
+      case AC_BK:
+        maxSize = m_bkMaxAmpduSize;
+        break;
+      case AC_VI:
+        maxSize = m_viMaxAmpduSize;
+        break;
+      case AC_VO:
+        maxSize = m_voMaxAmpduSize;
+        break;
+      default:
+        NS_ABORT_MSG ("Unknown AC " << ac);
+        return 0;
+    }
+  return maxSize;
+}
+
+uint16_t
+RegularWifiMac::GetMaxAmsduSize (AcIndex ac) const
+{
+  uint16_t maxSize = 0;
+  switch (ac)
+    {
+      case AC_BE:
+        maxSize = m_beMaxAmsduSize;
+        break;
+      case AC_BK:
+        maxSize = m_bkMaxAmsduSize;
+        break;
+      case AC_VI:
+        maxSize = m_viMaxAmsduSize;
+        break;
+      case AC_VO:
+        maxSize = m_voMaxAmsduSize;
+        break;
+      default:
+        NS_ABORT_MSG ("Unknown AC " << ac);
+        return 0;
+    }
+  return maxSize;
+}
+
 } //namespace ns3
